org.springframework.jdbc.support.lob

## Class OracleLobHandler

- java.lang.Object
- - org.springframework.jdbc.support.lob.AbstractLobHandler
  - - org.springframework.jdbc.support.lob.OracleLobHandler

- All Implemented Interfaces:
    LobHandler

      public class OracleLobHandler
      extends AbstractLobHandler

  `LobHandler` implementation for Oracle databases. Uses proprietary API to create `oracle.sql.BLOB` and `oracle.sql.CLOB` instances, as necessary when working with Oracle's JDBC driver. Note that this LobHandler requires Oracle JDBC driver 9i or higher!

  While most databases are able to work with `DefaultLobHandler`, Oracle just accepts Blob/Clob instances created via its own proprietary BLOB/CLOB API, and additionally doesn't accept large streams for PreparedStatement's corresponding setter methods. Therefore, you need to use a strategy like this LobHandler implementation.

  Needs to work on a native JDBC Connection, to be able to cast it to `oracle.jdbc.OracleConnection`. If you pass in Connections from a connection pool (the usual case in a J2EE environment), you need to set an appropriate `NativeJdbcExtractor` to allow for automatic retrieval of the underlying native JDBC Connection. LobHandler and NativeJdbcExtractor are separate concerns, therefore they are represented by separate strategy interfaces.

  Coded via reflection to avoid dependencies on Oracle classes. Even reads in Oracle constants via reflection because of different Oracle drivers (classes12, ojdbc14, ojdbc5, ojdbc6) having different constant values! As this LobHandler initializes Oracle classes on instantiation, do not define this as eager-initializing singleton if you do not want to depend on the Oracle JAR being in the class path: use "lazy-init=true" to avoid this issue.

  Since:
    04.12.2003
  Author:
    Juergen Hoeller, Thomas Risberg
  See Also:
    `setNativeJdbcExtractor(org.springframework.jdbc.support.nativejdbc.NativeJdbcExtractor)`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static interface` | `OracleLobHandler.LobCallback` Internal callback interface for use with createLob.
    `protected class` | `OracleLobHandler.OracleLobCreator` LobCreator implementation for Oracle databases.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Log` | `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OracleLobHandler()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `InputStream` | `getBlobAsBinaryStream(ResultSet rs, int columnIndex)` Retrieve the given column as binary stream from the given ResultSet.
    `byte[]` | `getBlobAsBytes(ResultSet rs, int columnIndex)` Retrieve the given column as bytes from the given ResultSet.
    `InputStream` | `getClobAsAsciiStream(ResultSet rs, int columnIndex)` Retrieve the given column as ASCII stream from the given ResultSet.
    `Reader` | `getClobAsCharacterStream(ResultSet rs, int columnIndex)` Retrieve the given column as character stream from the given ResultSet.
    `String` | `getClobAsString(ResultSet rs, int columnIndex)` Retrieve the given column as String from the given ResultSet.
    `LobCreator` | `getLobCreator()` Create a new `LobCreator` instance, i.e.
    `protected void` | `initializeResourcesBeforeRead(Connection con, Object lob)` Initialize any LOB resources before a read is done.
    `protected void` | `initOracleDriverClasses(Connection con)` Retrieve the `oracle.sql.BLOB` and `oracle.sql.CLOB` classes via reflection, and initialize the values for the DURATION_SESSION, MODE_READWRITE and MODE_READONLY constants defined there.
    `protected void` | `releaseResourcesAfterRead(Connection con, Object lob)` Release any LOB resources after read is complete.
    `void` | `setCache(boolean cache)` Set whether to cache the temporary LOB in the buffer cache.
    `void` | `setNativeJdbcExtractor(NativeJdbcExtractor nativeJdbcExtractor)` Set an appropriate NativeJdbcExtractor to be able to retrieve the underlying native `oracle.jdbc.OracleConnection`.
    `void` | `setReleaseResourcesAfterRead(boolean releaseResources)` Set whether to agressively release any resources used by the LOB.

    - ### Methods inherited from class org.springframework.jdbc.support.lob.AbstractLobHandler

      `getBlobAsBinaryStream, getBlobAsBytes, getClobAsAsciiStream, getClobAsCharacterStream, getClobAsString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          protected final Log logger

  - ### Constructor Detail

    - #### OracleLobHandler

          public OracleLobHandler()

  - ### Method Detail

    - #### setNativeJdbcExtractor

          public void setNativeJdbcExtractor(NativeJdbcExtractor nativeJdbcExtractor)

      Set an appropriate NativeJdbcExtractor to be able to retrieve the underlying native `oracle.jdbc.OracleConnection`. This is necessary for DataSource-based connection pools, as those need to return wrapped JDBC Connection handles that cannot be cast to a native Connection implementation.

      Effectively, this LobHandler just invokes a single NativeJdbcExtractor method, namely `getNativeConnectionFromStatement` with a PreparedStatement argument (falling back to a `PreparedStatement.getConnection()` call if no extractor is set).

      A common choice is `SimpleNativeJdbcExtractor`, whose Connection unwrapping (which is what OracleLobHandler needs) will work with many connection pools. See `SimpleNativeJdbcExtractor` and oracle.jdbc.OracleConnection javadoc for details.

      See Also:
        `NativeJdbcExtractor.getNativeConnectionFromStatement(java.sql.Statement)`, `SimpleNativeJdbcExtractor`, `OracleJdbc4NativeJdbcExtractor`

    - #### setCache

          public void setCache(boolean cache)

      Set whether to cache the temporary LOB in the buffer cache. This value will be passed into BLOB/CLOB.createTemporary.

      Default is `true`.

      See Also:

      - oracle.sql.BLOB.createTemporary
      - oracle.sql.CLOB.createTemporary

    - #### setReleaseResourcesAfterRead

          public void setReleaseResourcesAfterRead(boolean releaseResources)

      Set whether to agressively release any resources used by the LOB. If set to `true` then you can only read the LOB values once. Any subsequent reads will fail since the resources have been closed.

      Setting this property to `true` can be useful when your queries generates large temporary LOBs that occupy space in the TEMPORARY tablespace or when you want to free up any memory allocated by the driver for the LOB reading.

      Default is `false`.

      See Also:

      - oracle.sql.BLOB.freeTemporary
      - oracle.sql.CLOB.freeTemporary
      - oracle.sql.BLOB.open
      - oracle.sql.CLOB.open
      - oracle.sql.BLOB.close
      - oracle.sql.CLOB.close

    - #### initOracleDriverClasses

          protected void initOracleDriverClasses(Connection con)

      Retrieve the `oracle.sql.BLOB` and `oracle.sql.CLOB` classes via reflection, and initialize the values for the DURATION_SESSION, MODE_READWRITE and MODE_READONLY constants defined there.

      See Also:

      - oracle.sql.BLOB.DURATION_SESSION
      - oracle.sql.BLOB.MODE_READWRITE
      - oracle.sql.BLOB.MODE_READONLY
      - oracle.sql.CLOB.DURATION_SESSION
      - oracle.sql.CLOB.MODE_READWRITE
      - oracle.sql.CLOB.MODE_READONLY
      Parameters:
        `con` - the Oracle Connection, for using the exact same class loader that the Oracle driver was loaded with

    - #### getBlobAsBytes

          public byte[] getBlobAsBytes(ResultSet rs,
                              int columnIndex)
                                throws SQLException

      Description copied from interface: `LobHandler`
      Retrieve the given column as bytes from the given ResultSet. Might simply invoke `ResultSet.getBytes` or work with `ResultSet.getBlob`, depending on the database and driver.
      Parameters:
        `rs` - the ResultSet to retrieve the content from
        `columnIndex` - the column index to use
      Returns:
        the content as byte array, or `null` in case of SQL NULL
      Throws:
        `SQLException` - if thrown by JDBC methods
      See Also:
        `ResultSet.getBytes(int)`

    - #### getBlobAsBinaryStream

          public InputStream getBlobAsBinaryStream(ResultSet rs,
                                          int columnIndex)
                                            throws SQLException

      Description copied from interface: `LobHandler`
      Retrieve the given column as binary stream from the given ResultSet. Might simply invoke `ResultSet.getBinaryStream` or work with `ResultSet.getBlob`, depending on the database and driver.
      Parameters:
        `rs` - the ResultSet to retrieve the content from
        `columnIndex` - the column index to use
      Returns:
        the content as binary stream, or `null` in case of SQL NULL
      Throws:
        `SQLException` - if thrown by JDBC methods
      See Also:
        `ResultSet.getBinaryStream(int)`

    - #### getClobAsString

          public String getClobAsString(ResultSet rs,
                               int columnIndex)
                                 throws SQLException

      Description copied from interface: `LobHandler`
      Retrieve the given column as String from the given ResultSet. Might simply invoke `ResultSet.getString` or work with `ResultSet.getClob`, depending on the database and driver.
      Parameters:
        `rs` - the ResultSet to retrieve the content from
        `columnIndex` - the column index to use
      Returns:
        the content as String, or `null` in case of SQL NULL
      Throws:
        `SQLException` - if thrown by JDBC methods
      See Also:
        `ResultSet.getString(int)`

    - #### getClobAsAsciiStream

          public InputStream getClobAsAsciiStream(ResultSet rs,
                                         int columnIndex)
                                           throws SQLException

      Description copied from interface: `LobHandler`
      Retrieve the given column as ASCII stream from the given ResultSet. Might simply invoke `ResultSet.getAsciiStream` or work with `ResultSet.getClob`, depending on the database and driver.
      Parameters:
        `rs` - the ResultSet to retrieve the content from
        `columnIndex` - the column index to use
      Returns:
        the content as ASCII stream, or `null` in case of SQL NULL
      Throws:
        `SQLException` - if thrown by JDBC methods
      See Also:
        `ResultSet.getAsciiStream(int)`

    - #### getClobAsCharacterStream

          public Reader getClobAsCharacterStream(ResultSet rs,
                                        int columnIndex)
                                          throws SQLException

      Description copied from interface: `LobHandler`
      Retrieve the given column as character stream from the given ResultSet. Might simply invoke `ResultSet.getCharacterStream` or work with `ResultSet.getClob`, depending on the database and driver.
      Parameters:
        `rs` - the ResultSet to retrieve the content from
        `columnIndex` - the column index to use
      Returns:
        the content as character stream
      Throws:
        `SQLException` - if thrown by JDBC methods
      See Also:
        `ResultSet.getCharacterStream(int)`

    - #### getLobCreator

          public LobCreator getLobCreator()

      Description copied from interface: `LobHandler`
      Create a new `LobCreator` instance, i.e. a session for creating BLOBs and CLOBs. Needs to be closed after the created LOBs are not needed anymore - typically after statement execution or transaction completion.
      Returns:
        the new LobCreator instance
      See Also:
        `LobCreator.close()`

    - #### initializeResourcesBeforeRead

          protected void initializeResourcesBeforeRead(Connection con,
                                           Object lob)

      Initialize any LOB resources before a read is done.

      This implementation calls `BLOB.open(BLOB.MODE_READONLY)` or `CLOB.open(CLOB.MODE_READONLY)` on any non-temporary LOBs if `releaseResourcesAfterRead` property is set to `true`.

      This method can be overridden by sublcasses if different behavior is desired.

      Parameters:
        `con` - the connection to be usde for initilization
        `lob` - the LOB to initialize

    - #### releaseResourcesAfterRead

          protected void releaseResourcesAfterRead(Connection con,
                                       Object lob)

      Release any LOB resources after read is complete.

      If `releaseResourcesAfterRead` property is set to `true` then this implementation calls `BLOB.close()` or `CLOB.close()` on any non-temporary LOBs that are open or `BLOB.freeTemporary()` or `CLOB.freeTemporary()` on any temporary LOBs.

      This method can be overridden by sublcasses if different behavior is desired.

      Parameters:
        `con` - the connection to be usde for initilization
        `lob` - the LOB to initialize